import type { TypedDocumentNode as DocumentNode } from '@graphql-typed-document-node/core';
export type Maybe<T> = T | null;
export type InputMaybe<T> = Maybe<T>;
export type Exact<T extends {
    [key: string]: unknown;
}> = {
    [K in keyof T]: T[K];
};
export type MakeOptional<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]?: Maybe<T[SubKey]>;
};
export type MakeMaybe<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]: Maybe<T[SubKey]>;
};
export type MakeEmpty<T extends {
    [key: string]: unknown;
}, K extends keyof T> = {
    [_ in K]?: never;
};
export type Incremental<T> = T | {
    [P in keyof T]?: P extends ' $fragmentName' | '__typename' ? T[P] : never;
};
/** All built-in and custom scalars, mapped to their actual values */
export type Scalars = {
    ID: {
        input: string;
        output: string;
    };
    String: {
        input: string;
        output: string;
    };
    Boolean: {
        input: boolean;
        output: boolean;
    };
    Int: {
        input: number;
        output: number;
    };
    Float: {
        input: number;
        output: number;
    };
    /** A scalar that can represent any JSON value. */
    JSON: {
        input: any;
        output: any;
    };
};
export type AnyVersionContextObject = {
    __typename?: 'AnyVersionContextObject';
    deltas: Array<AnyVersionDeltaObject>;
    histories: Array<AnyVersionHistoryObject>;
    repo: AnyVersionRepositoryObject;
    storeRoot: Scalars['String']['output'];
};
export type AnyVersionDeltaObject = {
    __typename?: 'AnyVersionDeltaObject';
    deltaBackwardPath: Scalars['String']['output'];
    deltaBackwardSize: Scalars['Int']['output'];
    deltaForwardPath: Scalars['String']['output'];
    deltaForwardSize: Scalars['Int']['output'];
    fromHistoryId: Scalars['String']['output'];
    id: Scalars['String']['output'];
    repoId: Scalars['String']['output'];
    toHistoryId: Scalars['String']['output'];
};
export type AnyVersionHistoryObject = {
    __typename?: 'AnyVersionHistoryObject';
    ctime: Scalars['Int']['output'];
    fileHash: Scalars['String']['output'];
    fileSize: Scalars['Int']['output'];
    id: Scalars['String']['output'];
    message: Scalars['String']['output'];
    recovered: Scalars['Boolean']['output'];
    recoveryPath: Scalars['String']['output'];
    repoId: Scalars['String']['output'];
    sigPath: Scalars['String']['output'];
    sigSize: Scalars['Int']['output'];
};
export type AnyVersionRepositoryObject = {
    __typename?: 'AnyVersionRepositoryObject';
    changes: Array<Scalars['JSON']['output']>;
    ctime: Scalars['Int']['output'];
    filePath: Scalars['String']['output'];
    id: Scalars['String']['output'];
    lastHistoryId?: Maybe<Scalars['String']['output']>;
    mtime: Scalars['Int']['output'];
};
export type CommitRepositoryInput = {
    message: Scalars['String']['input'];
    removeOld?: InputMaybe<Scalars['Boolean']['input']>;
    repoId: Scalars['String']['input'];
};
export type CreateRepositoryInput = {
    filePath: Scalars['String']['input'];
    message: Scalars['String']['input'];
};
export type Mutation = {
    __typename?: 'Mutation';
    commitRepository: AnyVersionContextObject;
    createRepository: AnyVersionContextObject;
    pruneRepository: AnyVersionContextObject;
    recoverRepository: AnyVersionContextObject;
    rollbackRepository: AnyVersionContextObject;
    uncoverRepository: AnyVersionContextObject;
};
export type MutationCommitRepositoryArgs = {
    input: CommitRepositoryInput;
};
export type MutationCreateRepositoryArgs = {
    input: CreateRepositoryInput;
};
export type MutationPruneRepositoryArgs = {
    input: PruneRepositoryInput;
};
export type MutationRecoverRepositoryArgs = {
    input: RecoverRepositoryInput;
};
export type MutationRollbackRepositoryArgs = {
    input: RollbackRepositoryInput;
};
export type MutationUncoverRepositoryArgs = {
    input: UncoverRepositoryInput;
};
export type PruneRepositoryInput = {
    deltaIds: Array<Scalars['String']['input']>;
    historyIds: Array<Scalars['String']['input']>;
    repoId: Scalars['String']['input'];
};
export type Query = {
    __typename?: 'Query';
    getRepositories: Array<Repository>;
    getRepositoryByFilePath: AnyVersionContextObject;
    getRepositoryByRepoId: AnyVersionContextObject;
};
export type QueryGetRepositoryByFilePathArgs = {
    filePath: Scalars['String']['input'];
};
export type QueryGetRepositoryByRepoIdArgs = {
    repoId: Scalars['String']['input'];
};
export type RecoverRepositoryInput = {
    baseHistoryId: Scalars['String']['input'];
    deltaPaths: Array<Scalars['String']['input']>;
    historyId: Scalars['String']['input'];
    repoId: Scalars['String']['input'];
};
export type Repository = {
    __typename?: 'Repository';
    active: Scalars['Boolean']['output'];
    changes: Scalars['Int']['output'];
    filePath: Scalars['String']['output'];
    id: Scalars['Int']['output'];
    repoId: Scalars['String']['output'];
    storeRoot: Scalars['String']['output'];
};
export type RollbackRepositoryInput = {
    historyId: Scalars['String']['input'];
    repoId: Scalars['String']['input'];
};
export type UncoverRepositoryInput = {
    historyId: Scalars['String']['input'];
    repoId: Scalars['String']['input'];
};
export type ContextFieldsFragment = {
    __typename?: 'AnyVersionContextObject';
    storeRoot: string;
    repo: ({
        __typename?: 'AnyVersionRepositoryObject';
    } & {
        ' $fragmentRefs'?: {
            'RepositoryFieldsFragment': RepositoryFieldsFragment;
        };
    });
    histories: Array<({
        __typename?: 'AnyVersionHistoryObject';
    } & {
        ' $fragmentRefs'?: {
            'HistoryFieldsFragment': HistoryFieldsFragment;
        };
    })>;
    deltas: Array<({
        __typename?: 'AnyVersionDeltaObject';
    } & {
        ' $fragmentRefs'?: {
            'DeltaFieldsFragment': DeltaFieldsFragment;
        };
    })>;
} & {
    ' $fragmentName'?: 'ContextFieldsFragment';
};
export type RepositoryFieldsFragment = {
    __typename?: 'AnyVersionRepositoryObject';
    id: string;
    filePath: string;
    ctime: number;
    mtime: number;
    lastHistoryId?: string | null;
    changes: Array<any>;
} & {
    ' $fragmentName'?: 'RepositoryFieldsFragment';
};
export type HistoryFieldsFragment = {
    __typename?: 'AnyVersionHistoryObject';
    id: string;
    ctime: number;
    sigPath: string;
    sigSize: number;
    repoId: string;
    fileSize: number;
    fileHash: string;
    recovered: boolean;
    recoveryPath: string;
    message: string;
} & {
    ' $fragmentName'?: 'HistoryFieldsFragment';
};
export type DeltaFieldsFragment = {
    __typename?: 'AnyVersionDeltaObject';
    id: string;
    repoId: string;
    fromHistoryId: string;
    toHistoryId: string;
    deltaForwardPath: string;
    deltaBackwardPath: string;
    deltaForwardSize: number;
    deltaBackwardSize: number;
} & {
    ' $fragmentName'?: 'DeltaFieldsFragment';
};
export type CreateRepoMutationVariables = Exact<{
    input: CreateRepositoryInput;
}>;
export type CreateRepoMutation = {
    __typename?: 'Mutation';
    createRepository: ({
        __typename?: 'AnyVersionContextObject';
    } & {
        ' $fragmentRefs'?: {
            'ContextFieldsFragment': ContextFieldsFragment;
        };
    });
};
export type CommitRepoMutationVariables = Exact<{
    input: CommitRepositoryInput;
}>;
export type CommitRepoMutation = {
    __typename?: 'Mutation';
    commitRepository: ({
        __typename?: 'AnyVersionContextObject';
    } & {
        ' $fragmentRefs'?: {
            'ContextFieldsFragment': ContextFieldsFragment;
        };
    });
};
export type RollbackRepoMutationVariables = Exact<{
    input: RollbackRepositoryInput;
}>;
export type RollbackRepoMutation = {
    __typename?: 'Mutation';
    rollbackRepository: ({
        __typename?: 'AnyVersionContextObject';
    } & {
        ' $fragmentRefs'?: {
            'ContextFieldsFragment': ContextFieldsFragment;
        };
    });
};
export type PruneRepoMutationVariables = Exact<{
    input: PruneRepositoryInput;
}>;
export type PruneRepoMutation = {
    __typename?: 'Mutation';
    pruneRepository: ({
        __typename?: 'AnyVersionContextObject';
    } & {
        ' $fragmentRefs'?: {
            'ContextFieldsFragment': ContextFieldsFragment;
        };
    });
};
export type RecoverRepoMutationVariables = Exact<{
    input: RecoverRepositoryInput;
}>;
export type RecoverRepoMutation = {
    __typename?: 'Mutation';
    recoverRepository: ({
        __typename?: 'AnyVersionContextObject';
    } & {
        ' $fragmentRefs'?: {
            'ContextFieldsFragment': ContextFieldsFragment;
        };
    });
};
export type UncoverRepoMutationVariables = Exact<{
    input: UncoverRepositoryInput;
}>;
export type UncoverRepoMutation = {
    __typename?: 'Mutation';
    uncoverRepository: ({
        __typename?: 'AnyVersionContextObject';
    } & {
        ' $fragmentRefs'?: {
            'ContextFieldsFragment': ContextFieldsFragment;
        };
    });
};
export type QueryAllQueryVariables = Exact<{
    [key: string]: never;
}>;
export type QueryAllQuery = {
    __typename?: 'Query';
    getRepositories: Array<{
        __typename?: 'Repository';
        id: number;
        repoId: string;
        filePath: string;
        storeRoot: string;
        active: boolean;
        changes: number;
    }>;
};
export type QueryRepoQueryVariables = Exact<{
    repoId: Scalars['String']['input'];
}>;
export type QueryRepoQuery = {
    __typename?: 'Query';
    getRepositoryByRepoId: ({
        __typename?: 'AnyVersionContextObject';
    } & {
        ' $fragmentRefs'?: {
            'ContextFieldsFragment': ContextFieldsFragment;
        };
    });
};
export declare const RepositoryFieldsFragmentDoc: DocumentNode<RepositoryFieldsFragment, unknown>;
export declare const HistoryFieldsFragmentDoc: DocumentNode<HistoryFieldsFragment, unknown>;
export declare const DeltaFieldsFragmentDoc: DocumentNode<DeltaFieldsFragment, unknown>;
export declare const ContextFieldsFragmentDoc: DocumentNode<ContextFieldsFragment, unknown>;
export declare const CreateRepoDocument: DocumentNode<CreateRepoMutation, Exact<{
    input: CreateRepositoryInput;
}>>;
export declare const CommitRepoDocument: DocumentNode<CommitRepoMutation, Exact<{
    input: CommitRepositoryInput;
}>>;
export declare const RollbackRepoDocument: DocumentNode<RollbackRepoMutation, Exact<{
    input: RollbackRepositoryInput;
}>>;
export declare const PruneRepoDocument: DocumentNode<PruneRepoMutation, Exact<{
    input: PruneRepositoryInput;
}>>;
export declare const RecoverRepoDocument: DocumentNode<RecoverRepoMutation, Exact<{
    input: RecoverRepositoryInput;
}>>;
export declare const UncoverRepoDocument: DocumentNode<UncoverRepoMutation, Exact<{
    input: UncoverRepositoryInput;
}>>;
export declare const QueryAllDocument: DocumentNode<QueryAllQuery, Exact<{
    [key: string]: never;
}>>;
export declare const QueryRepoDocument: DocumentNode<QueryRepoQuery, Exact<{
    repoId: Scalars['String']['input'];
}>>;
